import { CONST_OPENAI_COM_KEY } from "../config";
import { ICommonResult } from "../utils/http";

const Router = require('koa-router'); // 引入koa-router
const mrRouter = new Router()

mrRouter.post('/jmg/moderations', async (ctx: {
  request: {
    body: {
      input: string,
      completion: string
    }
  },
  body: ICommonResult<boolean>
}, next: Function) => {
  const { input } = ctx.request.body
  const res = await fetch('https://api.openai.com/v1/moderations', {
    method: "POST",
    headers: {
      "Content-Type": "Content-Type: application/json",
      "Authorization": "Bearer " + CONST_OPENAI_COM_KEY
    },
    body: JSON.stringify({
      input
    })
  }).then(json => json.json())
  if (res && res.id) {
    const resObj = res as { id: string, model: string, results: { flagged: boolean }[] }
    if (resObj.results[0]) {
      return {
        Result: 1,
        code: 200,
        data: resObj.results[0].flagged
      } as ICommonResult<boolean>
    }
    else {
      return {
        Result: 0,
        code: 500,
        Reason: "somthing is wrong."
      } as ICommonResult<boolean>
    }
  }
})
