import { writeFile } from 'fs';
import path from 'path'
const txtFileFulPath = path.resolve(__dirname, '../../../public/merge_msg_userinfo.xlsx')

import { readFile, writeXLSX, utils } from "xlsx";
import { getPromptCompletion } from './util';

export function xlsx2jsonl() {
  var workbook = readFile(txtFileFulPath, {
    /** Input data encoding */
    type: 'string',
    sheets: ["Sheet1"],
  });
  const sheet = workbook.Sheets['Sheet1']
  const jsonRows: string[][] = utils.sheet_to_json(sheet, {
    header: 1,
  })
  let writeContent = ''
  for (let i = 1; i < jsonRows.length; i++) {
    const row = jsonRows[i]
    const userid = row[0]
    const dlgStr = row[1]
    const { prompt, completion } = getPromptCompletion(dlgStr)
    if (userid && prompt && completion && row[2]) {
      let userinfo = row[2] + '\n'
      // userinfo += 'My userid is ' + userid + '.\n'
      const _prompt = userinfo + '\n' + prompt

      writeContent += JSON.stringify({
        prompt: _prompt,
        completion: completion
      }) + '\n'
    }
  }

  const jsonlFileFulPath = txtFileFulPath.replace('.xlsx', '.jsonl')
  writeFile(jsonlFileFulPath, writeContent, (err) => {
    if (err) {
      console.log(jsonlFileFulPath + '写入失败')
    }
    else {
      console.log(jsonlFileFulPath + '写入成功')
    }
  })
  // if (rows) {
  //   for (let i = 1; i < rows.length; i++) {
  //     console.log('000000000000000=>', rows[i])
  //   }
  // }
}

export function xlsx2arr() {
  var workbook = readFile(txtFileFulPath, {
    /** Input data encoding */
    type: 'string',
    sheets: ["Sheet1"],
  });
  const sheet = workbook.Sheets['Sheet1']
  const jsonRows: string[][] = utils.sheet_to_json(sheet, {
    header: 1,
  })
  const arr: { userId: string, desc: string }[] = []
  for (let i = 1; i < jsonRows.length; i++) {
    const row = jsonRows[i]
    const userId = row[0]
    // const dlgStr = row[1]
    let userinfo = row[2] + '\n'
    // userinfo += 'My userid is ' + userId + '.\n'
    arr.push({
      userId: String(userId),
      desc: userinfo
    })
  }
  return arr
}
